/*

*/
import scene.*;
import scene.models.*;
import pipeline.*;
import framebuffer.*;

import java.awt.Color;

/**
   Rotate a square around its upper right hand corner.
   Do this by "accumulating" rotations.
*/
public class Example_03b
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render.
      Scene scene = new Scene();

      // Create a set of x and y axes.
      Model axes = new Axes2DModel(-2, +2, -2, +2, 8, 8);
      axes.setColor( Color.red );
      // Push the model away from where the camera is.
      axes.modelTranslate(0, 0, -2);
      scene.addModel(axes);


      // Create a FrameBuffer to render our scene into.
      int width  = 512;
      int height = 512;
      FrameBuffer fb = new FrameBuffer(width, height);


      Model square = new Model();
      square.addLineSegment(new LineSegment(new Vertex(0, 0, 0), new Vertex(1, 0, 0)));
      square.addLineSegment(new LineSegment(new Vertex(1, 0, 0), new Vertex(1, 1, 0)));
      square.addLineSegment(new LineSegment(new Vertex(1, 1, 0), new Vertex(0, 1, 0)));
      square.addLineSegment(new LineSegment(new Vertex(0, 1, 0), new Vertex(0, 0, 0)));
      // Give the model a random color.
      square.setColorRandom();
      // Add the square to the Scene.
      scene.addModel( square );

      // Push the square away from where the camera is.
      square.modelTranslate(0, 0, -2);

      //  Rotate a square around its upper right hand corner.
      //  Do this by "accumulating" rotations.
      square.modelTranslate(1.0, 1.0, 0);
      Matrix save = square.modelMatrix;
      for (int i = 0; i <= 60; i++)
      {
         square.modelTranslate(-1.0, -1.0, 0);

         // Render again.
         fb.clearFB(Color.black);
         Pipeline.render(scene, fb);
         fb.dumpFB2File(String.format("PPM_Example_Frame%03d.ppm", i));

         square.modelMatrix = save;
         square.modelRotate(6, 0,0,1); // accumulate a rotation
         save = square.modelMatrix;
      }
   }
}
