/*

*/
import scene.*;
import scene.models.*;
import pipeline.*;
import framebuffer.*;

import java.awt.Color;

/**
   Rotate the letter P around the perimeter of a circle.
   See the animation Example_14.gif.
*/
public class Example_14
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render.
      Scene scene = new Scene();

      // Create a set of x and y axes.
      Model axes = new Axes2DModel(-2, +2, -2, +2, 8, 8);
      axes.setColor( Color.red );
      scene.modelList.add(axes);
      // Push the model away from where the camera is.
      axes.modelTranslate(0, 0, -2);

      // Create a circle of radius 1.
      Model circle = new CircleModel(32, 1);
      circle.setColor( Color.green );
      scene.modelList.add(circle);
      // Push the model away from where the camera is.
      circle.modelTranslate(0, 0, -2);

      // Add a Model to the Scene.
      P p = new P();
      scene.addModel( p );

      // Give the model a random color.
      p.setColorRandom();

      // Create a FrameBuffer to render our scene into.
      int width  = 512;
      int height = 512;
      FrameBuffer fb = new FrameBuffer(width, height);

      // Rotate the letter P around the perimeter of the circle.
      for (int i = 0; i < 60; i++)
      {
         p.model2Identity();
         // Push the model away from where the camera is.
         p.modelTranslate(0, 0, -2);







         // Render again.
         fb.clearFB(Color.black);
         Pipeline.render(scene, fb);
         fb.dumpFB2File(String.format("PPM_Example_Frame%03d.ppm", i));
      }
   }
}
