/*

*/
import scene.*;
import scene.models.*;
import pipeline.*;
import framebuffer.*;

import java.awt.Color;

/**
   Translate the letter P along the y-axis while rotating around the letter's vertical center line (y=0.5).
*/
public class Example_26
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render.
      Scene scene = new Scene();

      // Create a set of x and y axes.
      Model axes = new Axes2DModel(-5, +5, -5, +5, 20, 20);
      axes.setColor( Color.red );
      scene.modelList.add(axes);
      // Push the model away from where the camera is.
      axes.modelTranslate(0, 0, -5);

      // Add a Model to the Scene.
      P p = new P();
      scene.addModel( p );

      // Give the model a random color.
      p.setColorRandom();

      // Create a FrameBuffer to render our scene into.
      int width  = 512;
      int height = 512;
      FrameBuffer fb = new FrameBuffer(width, height);

      // Push the model away from where the camera is.
      p.modelTranslate(0, 0, -5);

      // Translate along the y-axis while rotating around the letter's vertical center line (y=0.5).
      Matrix save = p.modelMatrix;
      for (int i = 0; i <= 50; i++)
      {
         p.modelMatrix = save;           // Undo both the rotation and translations.
         p.modelTranslate(0.5, 0, 0);
         p.modelRotate(i*36, 0,1,0);
         p.modelTranslate(-0.5, 0, 0);
         p.modelTranslate(0, i*0.1, 0);

         // Render again.
         fb.clearFB(Color.black);
         Pipeline.render(scene, fb);
         fb.dumpFB2File(String.format("PPM_Example_Frame%03d.ppm", i));
      }
   }
}
