/*

*/
import scene.*;
import scene.models.*;
import pipeline.*;
import framebuffer.*;

import java.awt.Color;

/**
   Rotate the letter P while scaling it twice as large for each rotation.
*/
public class Example_31
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render.
      Scene scene = new Scene();

      // Create a set of x and y axes.
      Model axes = new Axes2DModel(-4, +4, -4, +4, 16, 16);
      axes.setColor( Color.red );
      scene.modelList.add(axes);
      // Push the model away from where the camera is.
      axes.modelTranslate(0, 0, -4);

      // Add a Model to the Scene.
      P p = new P();
      scene.addModel( p );

      // Give the model a random color.
      p.setColorRandom();

      // Create a FrameBuffer to render our scene into.
      int width  = 512;
      int height = 512;
      FrameBuffer fb = new FrameBuffer(width, height);

      // Rotate the letter P while scaling it twice as large for each rotation.
      for (int i = 0; i <= 120; i++)
      {
         p.model2Identity();
         // Push the model away from where the camera is.
         p.modelTranslate(0, 0, -4);

         p.modelRotate(i*6, 0,0,1);
         double scale = Math.pow(2, i/60.0);
         p.modelScale(scale, scale, 1);

         // Render again.
         fb.clearFB(Color.black);
         Pipeline.render(scene, fb);
         fb.dumpFB2File(String.format("PPM_Example_Frame%03d.ppm", i));
      }
   }
}
