/*

*/
import scene.*;
import scene.models.*;
import pipeline.*;
import framebuffer.*;

import java.awt.Color;

/**
   Scale the letter P larger as its left edge
   forms a 45 degree diagonal from the positive
   y-axis to the positive x-axis.
*/
public class Example_35
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render.
      Scene scene = new Scene();

      // Create a set of x and y axes.
      Model axes = new Axes2DModel(-4, +4, -4, +4, 16, 16);
      axes.setColor( Color.red );
      scene.modelList.add(axes);
      // Push the model away from where the camera is.
      axes.modelTranslate(0, 0, -4);

      // Add a Model to the Scene.
      P p = new P();
      scene.addModel( p );

      // Give the model a random color.
      p.setColorRandom();

      // Create a FrameBuffer to render our scene into.
      int width  = 512;
      int height = 512;
      FrameBuffer fb = new FrameBuffer(width, height);

      // Scale the letter P larger as its left edge
      // forms a 45 degree diagonal from the positive
      // y-axis to the positive x-axis.
      for (int i = 2; i <= 64; i++)
      {
         p.model2Identity();
         // Push the model away from where the camera is.
         p.modelTranslate(0, 0, -4);

         double scale = Math.pow(i/2.0, 0.5);
         p.modelScale(scale, scale, 1);
         p.modelTranslate(1/Math.pow(2, 0.5), 0, 0);
         p.modelRotate(180, 0,1,0);
         p.modelRotate(-45, 0,0,1);
/*
         p.modelRotate( 45, 0,0,1);
         p.modelRotate(180, 0,1,0);
         double scale = Math.pow(i/2.0, 0.5);
         p.modelScale(scale, scale, 1);
         p.modelTranslate(-0.5, -0.5, 0);
*/
         // Render again.
         fb.clearFB(Color.black);
         Pipeline.render(scene, fb);
         fb.dumpFB2File(String.format("PPM_Example_Frame%03d.ppm", i));
      }
   }
}
